#include <stdio.h>
#include <string.h>

int main (int argc, char *argv[]) {
	char input[] = "The rain in Spain stays mainly in the plain!";
	char str_look_for[] = "in";
	char *pos, *remaining_str;
	int counter = 0;
	
	/* Find the first occurence of "in" in the input */
	pos = strstr(input, str_look_for);
	if (pos == NULL) {
		printf("%s not found in %s\n", str_look_for, input);
		return 1;
	}
	
	printf("%s found at address %p, position %ld\n", 
											str_look_for, pos, pos - input);
	
	printf("\n##\n");
	
	/* Now let's do something more interesting! Let's find all 
	 * occurences, starting again from the beginning */
	pos = strstr(input, str_look_for);	
	while (pos != NULL) {
		counter++;
		printf("Occurence %d of %s found at address %p, position %ld\n", 
									counter, str_look_for, pos, pos - input);
		/* We can use strstr to look for the next occurence, as long as 
		 * we start looking after the position where we found the previous
		 * occurence. We fix remaining_str to point right after the occurence
		 * of str_look_for we just found. Try to think why what we do is safe 
		 * and we do not risk reading after the end of the string in input. */
		remaining_str = pos + strlen(str_look_for);
		/* Call strstr for the remaining length of the string */
		pos = strstr(remaining_str, str_look_for);	
	}
	
	printf("\n##\n");

	/* Let's make it even more interesting by counting the number of 
	 * characters after the previous occurence */
	counter = 0;
	pos = strstr(input, str_look_for);
	while (pos != NULL) {
		counter++;
		printf("Occurence %d of %s found at address %p, position %ld", 
									counter, str_look_for, pos, pos - input);
		/* If this is not the first occurence, count characters after previous one */
		if (counter > 1) {
			printf(", %ld characters after previous occurence\n", pos - remaining_str);
		}
		else
			printf("\n");
		
		/* You know the drill... */
		remaining_str = pos + strlen(str_look_for);
		pos = strstr(remaining_str, str_look_for);	
	}
	
	return 0;
}
